 #
 #--------------------------------------------------------------------
 #   Include
 #--------------------------------------------------------------------
 import math as MT
 #
 #--------------------------------------------------------------------
 #   Solver
 #--------------------------------------------------------------------
 def SolverGeneralQuadraticEquation(a, b, c):
     D = b * b - 4 * a * c
     X1 = 0.0
     X2 = 0.0
     if (D < 0):
        return 0, X1, X2
     if (0 == D):
        X1 = -b / 2 / a
        X1 = X2
        return 1, X1, X2
     # 0 < D
     X1 = -(b + MT.sqrt(D)) / 2 / a
     X2 = -(b - MT.sqrt(D)) / 2 / a
     return 2, X1, X2
 #
 def SolverNormalizedQuadraticEquation(p, q):
     D = 0.25 * p * p - q
     X1 = 0.0
     X2 = 0.0
     if (D < 0):
        return 0, X1, X2
     if (0 == D):
        X1 = -p / 2
        X1 = X2
        return 1, X1, X2
     # 0 < D
     X1 = -p / 2 + MT.sqrt(D)
     X2 = -p / 2 - MT.sqrt(D)
     return 2, X1, X2
 #
 #--------------------------------------------------------------------
 #   Main
 #--------------------------------------------------------------------
 if ('__main__' == __name__):
     print('*** QuadraticEquation: begin')   
     #
     a = +3
     b = -15
     c = +18
     Ns, x1, x2 = SolverGeneralQuadraticEquation(a, b, c)
     print('GQE(a[%.3f], b[%.3f], c[%.3f]): Ns[%d] x1[%.3f] x2[%.3f]' % \
           (a, b, c, Ns, x1, x2))
     #
     p = -5
     q = +6
     Ns, x1, x2 = SolverNormalizedQuadraticEquation(p, q)
     print('NQE(p[%.3f], q[%.3f]): Ns[%d] x1[%.3f] x2[%.3f]' % \
           (p, q, Ns, x1, x2))
     #
     print('*** QuadraticEquation: end')
     #
#
